


#    support for Web Service access

global MIDAS_DataAcquisitionCode
set MIDAS_DataAcquisitionCode 8         ;#   initially state is undefined

#    state returns

#    code (int)  state (string)  reason  (string)

#       0           stopped
#       1           going
#       2           reset             "please setup"
#       3           setting up
#       4           changing to going
#       5           changing to stopped
#       6           error           ******
#       7           changing to reset
#       8           undefined       ******

set MIDAS_DataAcquisitionState(0) "stopped"
set MIDAS_DataAcquisitionState(1) "going"
set MIDAS_DataAcquisitionState(2) "reset"
set MIDAS_DataAcquisitionState(3) "setting up"
set MIDAS_DataAcquisitionState(4) "changing to going"
set MIDAS_DataAcquisitionState(5) "changing to stopped"
set MIDAS_DataAcquisitionState(6) "error"
set MIDAS_DataAcquisitionState(7) "changing to reset"
set MIDAS_DataAcquisitionState(8) "undefined"

set MIDAS_DataAcquisitionReason(0) ""
set MIDAS_DataAcquisitionReason(1) ""
set MIDAS_DataAcquisitionReason(2) "please setup"
set MIDAS_DataAcquisitionReason(3) "please wait"
set MIDAS_DataAcquisitionReason(4) "please wait"
set MIDAS_DataAcquisitionReason(5) "please wait"
set MIDAS_DataAcquisitionReason(6) "try reset"
set MIDAS_DataAcquisitionReason(7) "please wait"
set MIDAS_DataAcquisitionReason(8) "try reset"


#    This procedure is to be found in sys.common

#proc da_state {} {
#  global VXIEnable VMEEnable TSEnable RDOUTEnable
#  global vxistate vmestate tapestate readoutstate

#    if any one of the controlled subsystems is in the GO state then the
#    overall state is GO button

#  set state 0

#  if {$VXIEnable == 1 && $vxistate == 1}     then {set state 1}
#  if {$VMEEnable == 1 && $vmestate == 1}     then {set state 1}
#  if {$TSEnable == 1 && $tapestate == 1}     then {set state 1}
#  if {$RDOUTEnable == 1 && $readoutstate == 1}     then {set state 1}

#  return $state
#}

proc Get_State {} {
    global MIDAS_DataAcquisitionCode MIDAS_DataAcquisitionState MIDAS_DataAcquisitionReason

    if {$MIDAS_DataAcquisitionCode == 8} {set MIDAS_DataAcquisitionCode [da_state]}

    return [list $MIDAS_DataAcquisitionCode [set MIDAS_DataAcquisitionState($MIDAS_DataAcquisitionCode)] \
                 [set MIDAS_DataAcquisitionReason($MIDAS_DataAcquisitionCode)]]
}

proc do_Go    {} {
    global MIDAS_DataAcquisitionCode

    if {$MIDAS_DataAcquisitionCode == 8} {set MIDAS_DataAcquisitionCode [da_state]}

       if {$MIDAS_DataAcquisitionCode == 0} {
           set MIDAS_DataAcquisitionCode 4
           after 1 do-da 1
           set rc 0
       } else {
           set rc 1   ;#  currently in wrong state for requested action
       }
       return $rc
}

proc do_Stop  {} {
    global MIDAS_DataAcquisitionCode

    if {$MIDAS_DataAcquisitionCode == 8} {set MIDAS_DataAcquisitionCode [da_state]}

    if {$MIDAS_DataAcquisitionCode == 1 || $MIDAS_DataAcquisitionCode == 2 || $MIDAS_DataAcquisitionCode == 6} {
           set MIDAS_DataAcquisitionCode 5
           after 1 do-da 0
           set rc 0
    } else {
           set rc 1     ;#  currently in wrong state for requested action
    }
    return $rc
}

proc do_Setup {} {
       global MIDAS_DataAcquisitionCode

    if {$MIDAS_DataAcquisitionCode == 8} {set MIDAS_DataAcquisitionCode [da_state]}

       if {$MIDAS_DataAcquisitionCode == 0 || $MIDAS_DataAcquisitionCode == 2 || $MIDAS_DataAcquisitionCode == 6} {
           set MIDAS_DataAcquisitionCode 3
           after 1 do-setup 1
           set rc 0
       } else {
           set rc 1      ;#  currently in wrong state for requested action
       }
       return $rc
}

proc do_Reset {} {
       global MIDAS_DataAcquisitionCode

    if {$MIDAS_DataAcquisitionCode == 8} {set MIDAS_DataAcquisitionCode [da_state]}

       if {$MIDAS_DataAcquisitionCode == 0 || $MIDAS_DataAcquisitionCode == 2 || $MIDAS_DataAcquisitionCode == 6} {
           set MIDAS_DataAcquisitionCode 3
           after 1 do-setup 1
           set rc 0
       } else {
           set rc 1      ;#  currently in wrong state for requested action
       }
       return $rc
}

proc do-da {vl} {
   global MIDAS_DataAcquisitionCode

   set rc [catch {click-da $vl} m];    puts "click-da $vl returned rc=$rc and $m"

   if {$rc != 0} {
     puts "click-da $vl returned rc=$rc and $m"
      set MIDAS_DataAcquisitionCode 6
   } else {
      if {$m < 0} {set MIDAS_DataAcquisitionCode 6} else {set MIDAS_DataAcquisitionCode [da_state]}
   }
}

proc do-setup {vl} {
   global MIDAS_DataAcquisitionCode

   set rc [catch {click-setup $vl} m];    puts "click-setup $vl returned rc=$rc and $m"

   if {$rc != 0} {
     puts "click-setup $vl returned rc=$rc and $m"
      set MIDAS_DataAcquisitionCode 6
   } else {
      if {$m < 0} {set MIDAS_DataAcquisitionCode 6} else {set MIDAS_DataAcquisitionCode [da_state]}
   }
}
